<?php
//*************************************************************
//     The Dendrogrammer - production version
$version="1.0.5";//Set the version number
//*************************************************************
//created by David Allan Robb March to August 2011

//*************************************************************
//Additions
//v 1.0.1 Zoom help
//v 1.0.2:
//Handler for file missing if specified in manifest. Placed 
//Demo data echo into functions. Called when no data (as before)
//and when specified files are not found (NEW).
//If the specified node file is there and the leaf file is not
// then it tops up with dummy leafs
//v 1.0.3 Reports data description to heading of dendrogram
//v 1.0.4:
//Handles data files where the max dissimilarity is zero.
//Also reports dat file is missing if called with a read file not in data dir.
//v1.0.5:
//Amended dat file read code to simply read lines rather than csv items
//This allows filenames therin to contain commas 
//*************************************************************

//*************************************************************
//     PROCESSING STARTS HERE
//*************************************************************
//############## Get script location ########################

$this_file=$_SERVER['SCRIPT_NAME'];

// Define a path variable for use in a php redirection if needed
$webhost= $_SERVER['HTTP_HOST'];//the host server on MACS this is "www.macs.hw.ac.uk"
$this_file=$_SERVER['PHP_SELF'];//the path to this file within the host. If the
                                //is file was called "show_server_vars.php" and
                                //was placed in the top level of my www dir on MACS
                                // then it would be "/~dar14/show_server_vars.php"
$redir = "http://".$webhost.$this_file;//

//############## END OF Get script location ########################

//############## Dummy data echo functions ########################
//Added by D.Robb 19/8/2011 to deal with absence of data files that are
//albeit specified by the manifest file

//*************************************************************
//     echo demo node data FUNCTION DECLARATION
//*************************************************************
/** 
Function: 
echo_demo_node_data()

embeds demo node data into the html
Can be used in the absence of any data or if the specified node file is not found.
**/ 

function echo_demo_node_data() {

    echo '<input name="node1col0" type="hidden" value="1">';
    echo '<input name="node1col1" type="hidden" value="6">';
    echo '<input name="node1col2" type="hidden" value="0">';
    echo '<input name="node2col0" type="hidden" value="4">';
    echo '<input name="node2col1" type="hidden" value="7">';
    echo '<input name="node2col2" type="hidden" value="0">';
    echo '<input name="node3col0" type="hidden" value="2">';
    echo '<input name="node3col1" type="hidden" value="5">';
    echo '<input name="node3col2" type="hidden" value="0">';
    echo '<input name="node4col0" type="hidden" value="3">';
    echo '<input name="node4col1" type="hidden" value="8">';
    echo '<input name="node4col2" type="hidden" value="1">';
    echo '<input name="node5col0" type="hidden" value="9">';
    echo '<input name="node5col1" type="hidden" value="10">';
    echo '<input name="node5col2" type="hidden" value="2">';

return true;
}
// end of function declaration 
//############## END OF echo demo node data ########################

//*************************************************************
//     echo demo leaf data FUNCTION DECLARATION
//*************************************************************
/**
Function: 
echo_demo_leaf_data()

embeds demo leaf data into the html
Can be used in the absence of any data or if the specified leaf file is not found.
**/ 
function echo_demo_leaf_data() {

    echo '<input name="leaf1col0" type="hidden" value="Thing One">';
    echo '<input name="leaf1col1" type="hidden" value="Thing One long description">';
    echo '<input name="leaf2col0" type="hidden" value="Thing Two">';
    echo '<input name="leaf2col1" type="hidden" value="Thing Two long description">';
    echo '<input name="leaf3col0" type="hidden" value="Thing Three">';
    echo '<input name="leaf3col1" type="hidden" value="Thing Three long description">';
    echo '<input name="leaf4col0" type="hidden" value="Thing Four">';
    echo '<input name="leaf4col1" type="hidden" value="Thing Four long description">';
    echo '<input name="leaf5col0" type="hidden" value="Thing Five">';
    echo '<input name="leaf5col1" type="hidden" value="Thing Five long description">';
    echo '<input name="leaf6col0" type="hidden" value="Thing Six">';
    echo '<input name="leaf6col1" type="hidden" value="Thing Six long description">';
  
return true;
}
// end of function declaration 
//############## END OF leaf demo node data ########################

?>


<!DOCTYPE html>
<html>  
<head>  
  <title>Dendrogrammer</title>
  <meta charset="UTF-8"> 
  <meta http-equiv="X-UA-Compatible" content="IE=9" > 
  
  <!-- declarations for jQuery UI-->
  <link rel="stylesheet" href="../libraries/ui/jquery.ui.all.css">
  <!-- the application style sheet-->
  <link href="dendrogrammer_styles.css" type="text/css" rel="stylesheet"/>
  
  <!-- declare the library files
  	- the jQuery cross-browser API for JavaScript
  	- the Raphael cross-browser JavaScript graphics library
  	- the jQuery UI user JavaScript user interface API 
	-->
  <script src="../libraries/jquery-latest.min.js"></script>
  <script src="../libraries/raphael.js"></script>
  <!-- The Application code-->
  <script type="text/javascript" src="dendrogrammer.js"></script>
  <!-- declarations for jQuery UI-->
	<script src="../libraries/ui/jquery.ui.core.js"></script><!-- for widgets and effects -->
	<script src="../libraries/ui/jquery.ui.widget.js"></script><!-- for widgets and effects -->
	<script src="../libraries/ui/jquery.ui.mouse.js"></script><!-- for widgets and effects -->
	<script src="../libraries/ui/jquery.ui.tabs.js"></script><!-- tabs structure-->

  <!-- for pulsate effect on tab -->
	<script src="../libraries/ui/jquery.effects.core.js"></script>
	<!-- for pulsate effect on tab-->
	<script src="../libraries/ui/jquery.effects.pulsate.js"></script>
	<!-- for draggable effect in groups and for dialog-->
	<script src="../libraries/ui/jquery.ui.draggable.js"></script>
	
	<script src="../libraries/ui/jquery.ui.position.js"></script><!-- for dialog-->
	<script src="../libraries/ui/jquery.ui.dialog.js"></script><!-- for dialog-->
	<script src="../libraries/ui/jquery.ui.button.js"></script><!-- for buttons-->

  <!-- END OF declarations for jQuery UI-->
	

</head>  
<body>
<?php
//check if a read file is specified. if so check if it exists. If the file does not exist
//output a message to say so and stop.
if(isset($_GET['read'])){
    //if the file requested in the querystring does not exist then advise use of back button
    $requested_file='data/'.$_GET['read'];
	if (!file_exists($requested_file)){
		echo '<h1>Sorry the file requested to be displayed with the dendrogrammer does not exist</h1>';
		echo '<h2>Please use your back button</h2>';
		echo '</body>';
		echo '</html>';
		exit;
    }
}
?>
<div id="wrapperForCentring">
<div id="centre">

<!-- centre div Page Content goes HERE -->

	<span class="theHeading" >The Dendrogrammer</span>
	<div id="tabs">
	<!-- Tabs Div contains the tab list followed by all the tab divs -->
	
	<!-- Tabs List -->
		<ul>
			<li><a href="#tabs-1" title="View a dendrogram">Dendrogram</a></li>
			<li><a href="#tabs-2" title="Load a new data set">Data</a></li>
			<li><a href="#tabs-3" id="pulser" title="Access groups detail" >Groups</a></li>
			<!-- COMMENT OUT tracer tab list element
			<li><a href="#tabs-4">Program Variables (Tracer)</a></li>
			-->
			<li><a href="#tabs-5" title="Read about the application">About</a></li>
			<li><a href="#tabs-6" title="A brief user guide">Help</a></li>
			<li><a href="#tabs-7" title="How to zoom in and out">Zoom Help</a></li>
		</ul>
	<!-- END OF Tabs List -->
	
	<!-- Start of the individual tab divs -->
	<div id="tabs-1"><!-- Start of tab 1 div -->
		
		  <span class="theHeading" title="A dendrogram is a tree diagram with all the 
          leaves at one end.">Dendrogram</span>&nbsp;&nbsp;<span id="theDataDescription" >Demo data</span>
      <br />Look under the "Help" tab above for the Quick-start guide.
			<br /><br />
			<span id="adjusterToolbar" title="Threshold Toolbar" 
                                        class="ui-widget-header ui-corner-all">

				<button id="zeroButton">zero</button>
				<button id="lessButton">less</button>
				<button id="minusButton">minus</button>
				<input type="text" id="amount" size="7"  title="Threshold value field"
					style="border:0; color:#f6931f; font-weight:bold; text-align: center" />
				<button id="plusButton">plus</button>
				<button id="moreButton">more</button>
				<button id="maxButton">max</button>
	
				<input type="button" id="groupingButton" title="Apply new threshold"
							value="Apply threshold" />
				<input type="button" id="removeGroupsButton" title="Remove groups"
							value="Remove" />
				<input type="button" id="truncateButton" title="Truncate below threshold"
							value="Truncate" />
				<input type="button" id="restoreButton" title="Restore leaves"
							value="Restore" />

			</span>&nbsp;&nbsp;
			<span id="groupsNoSetToolbar" title="Set no. of groups Toolbar" 
                                        class="ui-widget-header ui-corner-all">
				<input type="text" id="groupNo" size="2" title="No. of groups field"
            style="border:0; color:#f6931f; font-weight:bold; text-align: center" />
				<input type="button" id="useGroupNoButton" title="Apply no. of groups"
							value="Apply no. of groups" />

			</span>
			
		
		<div id="graph"> <!-- Graph div contains the dendrogram div -->
			<div id="canvas_container" >
    		</div>
  		</div><!-- END OF Graph div -->
  		
	</div><!-- END OF tab 1 div -->
	
	<div id="tabs-2"><!-- Start of tab 2 div -->
	  <h2>Load different data</h2>
		
    <?php
    
    //*************************************************************
    //     File reading script starts here
    //*************************************************************
    
    //get the directory listing
    $dirlist = scandir('./data');
    $found_one_dat=false;//flag to note when a csv is present
    $first_found_dat="nofile.dat";//ready for storing filename
    
    echo 'Load a different data set by clicking one of the links in the table below.';
    //create a table for displaying links for changing selected file
    //start table
    echo "<table >";
    //loop through the directory list
    foreach ($dirlist as $key => $filename) {
        // if the filename contains the ".dat" then display it
        if (strpos($filename, ".dat")){
            //start a new row
            echo "<tr>";
            //store the first found csv name
            if (!$found_one_dat){
                $first_found_dat=$filename;
            } 
            $found_one_dat=true;
            echo "<td>";//start the new cell
            //display the file loading link building a url querystring like this:
            //applicationfile.php?read=somefile.csv&w=1280
            echo "<a href='".$redir."?read=".$filename."'>".$filename."</a><br>";
            echo "</td>";// close the cell
            //end the row
            echo "</tr>";
        }//END if (strpos($filename, ".dat"))      
    }//end foreach ($dirlist as $key => $value)
    // finish the table
    echo "</table>"; 
    
    //if no data file was found then output a message about this
    if(!$found_one_dat){
        echo '<h2>No .dat file in the data directory</h2>';
        echo 'Regretably there is no loadable data in the data directory. ';
        echo 'A .dat file containing the names of the node and leaf data files needs to ';
        echo 'be uploaded to a folder called <i>data</i> in the application directory ';
        echo 'by ftp before this application can be useful. (Someone with write access ';
        echo 'to the application directory would need to do this.) ';
        echo 'The csv files named in the dat file also need to be present in the directory. ';
        echo 'The node data needs to be a 3-column csv file containing clustering data';
        echo ' and the feaf data should be a 2-column csv file containing leaf ';
        echo 'description data. ';
    }
    
    //check the GET data to see if the user has chosen a file
    //if not then load the data for the first displayed csv file and offer that
    
    if(isset($_GET['read']))
    {
    $filename=$_GET['read'];
    }else{
      $filename=$first_found_dat; 
      //$filename="default.dat"; 
    }

    //http://www.macs.hw.ac.uk/cgi-bin/ips/echo
    //prototype_3_0_1.php
    ?>

    <h2>The current data</h2>
    Below are details of the currently loaded data set:<br />
    The largest merge height (dissimilarity value) is 
    <span class="dimension" id="largestMergeHt">0</span>.<br />
    There are <span class="dimension" id="leafNodes">0</span> leaf nodes.<br />
    <!-- start the data form  -->
    
    <!-- the form has no submit button. It is purely for the purpose of containing-->
    <!-- data within input elements which are harvested by the JavaScript code.    -->
    <form name="myForm" id="dataForm" 
        action="no-action.php"
        method="POST"> <!-- the form has no submit button. It is purely for the purpose -->
    
    <?php
    
    //if no data was found output a messege else read data and build the form.
    
    if (!$found_one_dat){
        echo '<h2>Hard coded example data loaded</h2>';
        echo 'Some hard coded example data has been loaded for the ';
        echo 'time being, for demonstration purposes.';
        
    ?>    
    <!-- dummy data  -->
    <!-- dummy file name data  -->
    <input type="hidden" name="fileName" value="example.dat"/>

    <input name="dat1col0" type="hidden" value="example.node.csv">
    <input name="dat2col0" type="hidden" value="example.leaf.csv">
    
    <!-- node data  -->
    <?php
    echo_demo_node_data();       
    ?> 

    <!-- leaf description data  -->
    <?php
    echo_demo_leaf_data();       
    ?> 
    <!-- END OF the dummy data -->    
    <?php 
        
        
    }else{
        echo '<input type="hidden" name="fileName" value="'.$filename.'"/>';
        ###########################################################
        # PHP csv file read
        # based on code from PHP.net
        # http://php.net/manual/en/function.fgetcsv.php
        
        #Ready an array to hold two filenames. Initialise with two empy strings
        $filenames=array('','');
        
        #First the dat file read  
        $row = 1;
        if (($handle = fopen("data/".$filename, "r")) !== FALSE) {
            echo "<h3>Dat file name=$filename</h3>";
            echo "It contains the following data file names and description text:";
            echo "<table><tr><td>Line No</td><td>File name</td></tr>";
            //read the file lines
            while(! feof($handle)) {
                //get one line
                $data=fgets($handle);
                //buid the dislpay table row
                echo "<tr>";
                echo '<td>'.$row.'</td>';  
                echo '<td>'.$data.'<input name="dat'.$row.'col'.$c.'" type="hidden" value="'.trim($data).'"></td>';
                //assign to filenames array
                $filenames[$row-1]=trim($data);
                echo "</tr>";//end of that data line
                $row++;
            }
            echo "</table>";
            fclose($handle);
        }
    
        #Next csv data files themselves
        
        #read the node file
        #Now read the first csv data file. This should be 
        #the 3 column node dat file else errors will occur
        $row = 1;
        if (($handle = fopen("data/".$filenames[0], "r")) !== FALSE) {
            echo "<h3>Node file name=$filenames[0]</h3>";
            echo "<table><tr><td>Line No</td><td>col1</td><td>col2</td><td>col3</td></tr>";
            while (($data = fgetcsv($handle, 1000, ",")) !== FALSE) {
                echo "<tr>";
                $num = count($data);// not needed but keep for now
                //make an input element like this:
                // <input name="row1no" type="hidden" value="1">
                echo '<td>'.$row.'</td>';  
                for ($c=0; $c < $num; $c++) {
                    echo '<td>'.$data[$c].'<input name="node'.$row.'col'.$c.'" type="hidden" value="'.$data[$c].'"></td>';
                }
                echo "</tr>";//end of that data line
                $row++;
            }
            $last_node_row=$row-1;
            echo "</table>";
            fclose($handle);
        } else {
            echo "<h3>File name=$filenames[0] not found</h3>";
            echo "<p>Attempting to load demo data</p>";
            echo_demo_node_data();    
        }
        
        #read the leaf file
        #Now read the second csv data file. This should be 
        #the two column leaf data file else errors will occur
        $row = 1;
        if (($handle = fopen("data/".$filenames[1], "r")) !== FALSE) {
            echo "<h3>Leaf file name=$filenames[1]</h3>";
            echo "<table><tr><td>Line No</td><td>col1</td><td>col2</td></tr>";
            while (($data = fgetcsv($handle, 1000, ",")) !== FALSE) {
                echo "<tr>";
                $num = count($data);// not needed but keep for now
                //make an input element like this:
                // <input name="row1no" type="hidden" value="1"> 
                echo '<td>'.$row.'</td>';  
                for ($c=0; $c < $num; $c++) {
                    echo '<td>'.$data[$c].'<input name="leaf'.$row.'col'.$c.'" type="hidden" value="'.$data[$c].'"></td>';
                }
                echo "</tr>";//end of that data line
                $row++;
            }
            echo "</table>";
            fclose($handle);
        } else {
          echo "<h3>File name=$filenames[1] not found</h3>";
          echo "<p>Attempting to load demo data</p>";
          echo_demo_leaf_data();
          //check if real node ata was loaded. If so top up with fake leaf nodes                     
          if(isset($last_node_row)){
              echo "<p>The six demo leaves are not enough. Topping up with fake leaf data.</p>";
              echo "<table><tr><td>Line No</td><td>col1</td><td>col2</td></tr>";          
              //This means real node data was loaded.
              //The expected no of leafs will be no. of node rows plus 1 
              //demo data contains 6 leafs
              //loop from 7 to fill up the leaf count to match the node data
              $row=7;
              while ($row<$last_node_row+2){           
                echo "<tr>";
                //make an input element like this:
                // <input name="row1no" type="hidden" value="1"> 
                echo '<td>'.$row.'</td>'; 
                    echo '<td>Dummy leaf<input name="leaf'.$row.'col0" type="hidden" value="Dummy leaf"></td>'; 
                    echo '<td>Dummy leaf long description<input name="leaf'.$row.'col1" type="hidden" value="Dummy leaf long description"></td>';
                echo "</tr>";//end of that data line
                $row++;
              }
              echo "</table>";            
          }        
        }
        
        
    }//END if (!$found_one_dat){
    
    //*************************************************************
    //     END of file reading script
    //*************************************************************
    
    ?>
    </form><!-- END OF the data form  -->
	</div><!-- END of tab 2 div -->
	
  	<div id="tabs-3"><!-- Start of tab 3 div -->
  		<div id="groupsOutput"><!-- Start of groupsOutput div -->
			<h1>Groups data will be displayed here.</h1>
  			<div class="output">
  				<p>Here will appear output in response to formation 
  				of groups using the green dragable threshold bar and the "Apply threshold" 
  				button, or the "Set no.of groups" toolbar.</p>     
  			</div>
  		</div><!-- END of groupsOutput div -->
  		
  		<!-- dialog for notifying group formation-->
		<div id="dialog-groups" title="Groups">
		</div>
  		
	</div><!-- END of tab 3 div -->
	
	<!-- Start of tab 4 div -->
	<!-- COMMENT OUT tracer div (tabs-4 div) 	
	<div id="tabs-4">	
    		<span class="theHeading" >Program variable values</span><br />
        	The canvas X setting is <span class="dimension" id="xDim">0</span><br />
        	and Y is <span class="dimension" id="yDim">0</span>. <br />
        	iPad status: <span class="dimension" id="iPadStatus">0</span>. <br />
        	<div id="traceDump">TraceDump Starts here:</div>
	</div>-->
	<!-- END of tab 4 div -->
	
	<div id="tabs-5"><!-- Start of tab 5 div -->
		<span class="theHeading" >Dendrogrammer v <?php echo $version; ?> </span>
		<br /><br />
    The Dendrogrammer was created as one component in the analysis of 
    multivariate data. In particular it is intended to allow already 
    pre-processed data to be
    
		<ul> 
			<li>classified into groups and then either </li>
			<li>used in further analysis, or</li>
			<li>used in some form of presentation about the data.</li>
		</ul>
		Current Features
		<ul>  
			<li>Dendrogram construction</li>
			<li>File read</li>
			<li>File read now includes a manifest file which cues a clustering data file 
					(node data) and a leaf description data file (leaf data).</li>
			<li>File read now is integrated in the application page. Hard coded data 
				loads if no data files are found.</li>
			<li>Window width optimisation</li>
			<li>Group formation by adjustable threshold</li>
			<li>Cluster click/tap reports into dialog</li>
			<li>Group formation reports with dialog, reports into separate tab, 
					that tab pulses to notify. The pulsing stops when the tab is clicked</li>
			<li>The threshold is a dragable element on the graph</li>
			<li>The threshold can be adjusted also using toolbar buttons</li>
			<li>The desired number of groups can be entered and it will set 
					the threshold to fit</li>
			<li>Leaf labels on the vertical axis. These are interactively styled in response
				to events.</li>
			<li>Dialogs now guaranteed to be under 75% of window ht, scrolling if needed
				and using a default or wider width as appropriate on PC platform. 
				Scrolling dialogs are not deployed on tablet platform as these are 
				not suitable for tablets. </li>
			<li>The group banding (and groups) can be removed with the "Remove" button</li>	
			<li>Summary dendrogram: For use in dendrograms with a very large number of
				leaves. Effectively truncating the dendrogram up from 0 ht to a level at 
				which the structure can be discerned and then the clusters interrogated, 
				rather than having hundreds of leaves along the bottom.</li>
			<li>The Descendant Nodes Dialog contains a search link. The URL for this is
				specified in the .dat file which loads the data. The search link passes
				the cluster's leaf terms to a search engine.</li>	
		</ul>
		Documentation
		<ul> 
			<li><a href="../doc/index.html">JavaScript code documentation</a></li>
			<li><a href="../Readme.txt">Readme file</a></li>
	
		</ul>

    The technologies deployed in the application include
		<ul> 
			<li>JavaScript - The major part of the application is written in JavaScript</li>
			<li><a href="http://raphaeljs.com/">Raphael</a> Javscript library 
				(by <a href="http://dmitry.baranovskiy.com/">Dmitry Baranovskiy</a>)
				- Used to make the dendrogram graphic elements. Raphael is truly amazing.</li>
			<li>(Indirectly) SVG and VML - Raphael uses SVG or VML to do the drawing. 
        Raphael switches seemlessly	depending on the browser </li>
			<li><a href="http://jquery.com/">jQuery</a> - For some of the cross browser Dynamic HTML</li>
			<li><a href="http://jqueryui.com/">jQuery UI</a> - For some of the user 
          interface supporting the application</li>
			<li>HTML5 - Although there is nothing especially HTML5 about it really. </li>
			<li><a href="http://php.net/">PHP</a> - the data files are loaded using PHP.</li>
		
		</ul>
		The Dendrogrammer was created
		<ul> 
			<li>by David Allan Robb</li>
			<li>for his MSc project at Heriot-Watt University</li>
			<li>in summer 2011</li>
		</ul>
	</div><!-- END of tab 5 div -->

	<div id="tabs-6"><!-- Start of tab 6 div -->

		<span class="theHeading" >Quick-start Guide</span><br /><br />
		In a nutshell-
	<ul>
					<li>Drag the green bar (Threshold bar)
    			to adjust the dissimilarity threshold for group formation.
          Then click the "Apply threshold" button to form groups.</li> 
          <li>"Remove" will get rid of the groups.</li>
          <li>Or enter the desired no. of groups in the "no. of groups field" and 
    			click the "Apply no. of groups" button. </li>
          <li>To create a summary dendrogram, drag the threshold, then click 
    			"Truncate". </li>
    			 <li>"Restore" redraws the original dendrogram.</li>
    			 <li>Another way to adjust the threshold is to enter a number in the
           "Threshold value field".</li>
	</ul>
	<span class="theHeading" >Help</span>
  <h3>Dendrogram tab - View and interact with the dendrogram made from the clustering data.</h3>
		<ul>
					<li>Click or tap a cluster (element on the graph). 
					Then read about that cluster in the dialog that appears.</li>
					<li>That dialog also contains a search link. The URL for this is specified
					    in the .dat file which loads the data. The search link passes the 
					    cluster's leaf terms to a search engine. It should open in a 
					    browser pop-up window or browser tab.</li>
					<li>Adjust the green threshold bar and click the button to form groups of 
						leaves (data points)</li>
					<li>See more detail about the groups you form under the "Groups" tab.</li>
					<li>The threshold can be adjusted by click-and-drag on the green bar,
						or using the threshold toolbar buttons, or entering a number in the
            			"Threshold value field". </li>
					<li>If you are using a tablet computer then drag on the green bar
						with your finger. If you find you can't drag the bar accurately then
						use the toolbar buttons to move the threshold. You might find that 
						after moving the threshold bar away from the max with a button then you can get
						a better feel for how it drags using your finger.</li>
					<li>If using the toolbar fine adjust buttons (plus and minus), note that 
						the amount of movement with minus is set slightly less that with plus. 
						This allows even more fine adjustment if you alternate from
						plus to minus around the point you are looking for.
						</li>
					<li>To specify a given number of groups, enter the desired number in the
						field next to the "Apply no.of groups" button and click the button. 
						The threshold will be chosen automatically for you.</li>
					<li>To view a summary dendrogram (or truncated dendrogram),
						drag the threshold to some point below which you wish to discard
						the leaf detail. Then click the "Truncate" button. The resulting 
						summary dendrogram will have everything below the threshold
						removed and be reshaped to fit the previous space. The origin is at the
						dissimilarity ht. you chose with the threshold bar. Tapping/clicking
						a cluster will still report all the leaf detail as before,
						despite the leaves being invisible. Groups can be formed in the same 
						manner as before.
						</li>
					<li>The "Restore" button will restore the original full dendrogram and 
						the leaves as it was when you first viewed the current data. 
						Loading new data or the same data again will have the same effect,
						as will reloading the page with your browser.
						</li>
					<li>Use Control and + or - to zoom in and out ( or pinch on a tablet ). 
						Look in your browser's View menu for more zoom controls.</li>	
					<li>What equipment to use: The dendrogrammer was designed to be cross platform
						(works on PCs with mouse and tablets with tap)</li>
					<li>What browser to use: The dendrogrammer was designed to be cross browser. It
						is written in JavaScript (with a little bit of PHP to load the data). So it
						works in pretty much any browser that has Javascript enabled. However it is
						my experience that if one considers the latest browsers, the JavaScript 
						interpreters in Firefox (Gekko with Tracemonkey), Safari (Webkit with 
						Squirrelfish), and Chrome (Webkit with V8) are significantly faster (e.g. 
            			by a factor of 2 and more) than the 
            			"JScript" engine in Internet Explorer 8 and below (However, IE9 32-bit is 
            			good, but IE9 64-bit is reputed to be slow). 
						So if one is seeking faster smoother performance with this particular
						application then one might wish to use Firefox, Chrome, or Safari 
            			(as at July 2011).</li>						
				</ul>		
        <h3>Data tab - Load different data or find out about the current
            data used to make the dendrogram.</h3>
        <ul>
					<li>A table of links is shown representing all the available data sets. 
              Clicking a link loads that data set and makes a dendrogram from it.</li>
          <li>The currently loaded data set is described and displayed in 3 tables</li>
          <li>One table shows the contents of the .dat (or manifest) file. This 
              contains meta data about the data set: the names of the two data files
              and a description of the data set.</li>
          <li>The next table shows the contents of the clustering data file (or node
              file). This should be a csv file generated by MATLAB. It should have  
              3 columns. The first two columns are cluster or leaf designation  
              numbers. The third column contains the merge height or similarity 
              measure for that cluster.</li>
          <li>The last table shows the contents of the leaf description data file (or leaf
              file). This is a csv file. The first row describes leaf number one. The second
              row describes leaf number two and so on. It should contain two columns. Column
              one should hold the short leaf descriptions or labels. Column 2 should contain
              a longer description for each leaf (this can be a repeat of the short label).
              </li>
     			<li>Loading a new data set or the same data set again will result in a page
     			refresh and will clear any displayed groups or summary dendrogram which you may 
     			be displayed on the Dendrogram tab.
			   </li>
     		<li>Adding further data sets can only be done by someone with write-access
     			to the web space where the application resides (See 'Documentation'
     			in the About tab.)
			</li>
						
				</ul>
			<h3>Groups tab- View the detail of the groups formed using the threshold adjuster 
				and toolbar. </h3>
				<ul><li>
				The detail can be copied and pasted into other software for 
				further analysis or presentation.</li>
				</ul>
			<h3>About tab - Read about the application.</h3>
			<h3>Help tab - This page you are reading now is the Help.</h3>
	</div><!-- END of tab 6 div -->
	
	<div id="tabs-7"><!-- Start of tab 7 div -->

		<span class="theHeading" >Zoom Help</span><br /><br />
		If you find the leaf labels too small you may wish to zoom in. 
		If you find your screen height too small to fit a large dendrogram
		you may wish to zoom out.
		<h3>How to zoom on a PC or laptop</h3>
		<ul>
				<li>On most browsers <strong><em>Control</em></strong> and 
					<strong><em> + </em></strong> will zoom in.</li> 
          		<li><strong><em>Control</em></strong> and <strong><em> - </em></strong> 
          			will zoom out.</li>
          		<li><strong><em>Control</em></strong> and <strong><em> mouse 
          			wheel</em></strong> works too on most browsers.</li>
          		<li>Look in your browser's View menu for more zoom commands. E.g.
          			Some browsers offer a separate zoom for text only. If using that,
          			bear in mind that your browser sees the entire dendrogram including
          			leaf labels as graphics.</li>
			<li>Once you have zoomed, refreshing the page will adjust the dendrogram 
			to fit the width you have chosen.</li>
		</ul>

		<h3>On a tablet device</h3>	
		<ul>
				<li>Use the open or close pinch gesture to zoom.</li> 
          		<li>Once you have zoomed in, as you would expect, refreshing the page 
          		does not affect the dendrogram size. It remains zoomed until you 
          		zoom back.</li>	 
		</ul>
    <h3>Summary Dendrogram feature</h3>
		<ul>
				<li>By setting the threshold bar and clicking "Truncate" you can
					reduce the amount of leaf detail displayed and reduce the height of
					the dendrogram.</li> 
          		<li>Clicking a cluster on a summary dendrogram still reveals all of
          			its descendant leaf detail in the dialogs. Group formation works
          			as normal.</li>	 
				<li>The "Restore" button restores the normal dendrogram.</li>	
		</ul>

	</div><!-- END of tab 7 div -->

</div><!-- END OF Tabs Div-->

	
</div><!-- end of centre div -->  
</div><!-- end of wrapperForCentring -->
</body>  
</html>  
 
